From 4424edf260025e11c37795921bbd42a22eba9dc6 Mon Sep 17 00:00:00 2001
From: Harika Nukala <harika.nukala@sap.com>
Date: Mon, 21 Nov 2016 18:58:22 -0800
Subject: [PATCH] bot configuration settings

---
 src/configs/Config.php                             |   4 +-
 src/configs/Createdb.php                           |   8 +-
 .../components/AccountaccessComponent.php          |  28 ++
 src/controllers/components/SystemComponent.php     |   6 +
 src/library/VersionFunctions.php                   |  11 +
 src/locale/ar/configure.ini                        | 285 +++++++++++----------
 src/locale/bn/configure.ini                        | 285 +++++++++++----------
 src/locale/de/configure.ini                        | 285 +++++++++++----------
 src/locale/en_US/configure.ini                     | 285 +++++++++++----------
 src/locale/es/configure.ini                        | 285 +++++++++++----------
 src/locale/fa/configure.ini                        | 285 +++++++++++----------
 src/locale/fr_FR/configure.ini                     | 285 +++++++++++----------
 src/locale/he/configure.ini                        | 285 +++++++++++----------
 src/locale/hi/configure.ini                        | 285 +++++++++++----------
 src/locale/in_ID/configure.ini                     | 285 +++++++++++----------
 src/locale/it/configure.ini                        | 285 +++++++++++----------
 src/locale/ja/configure.ini                        | 285 +++++++++++----------
 src/locale/kn/configure.ini                        | 285 +++++++++++----------
 src/locale/ko/configure.ini                        | 285 +++++++++++----------
 src/locale/nl/configure.ini                        | 285 +++++++++++----------
 src/locale/nl/statistics.txt                       |   0
 src/locale/pl/configure.ini                        | 285 +++++++++++----------
 src/locale/pt/configure.ini                        | 285 +++++++++++----------
 src/locale/ru/configure.ini                        | 285 +++++++++++----------
 src/locale/te/configure.ini                        | 285 +++++++++++----------
 src/locale/te/statistics.txt                       |   2 +-
 src/locale/th/configure.ini                        | 285 +++++++++++----------
 src/locale/tr/configure.ini                        | 285 +++++++++++----------
 src/locale/vi_VN/configure.ini                     | 285 +++++++++++----------
 src/locale/zh_CN/configure.ini                     | 285 +++++++++++----------
 src/models/ProfileModel.php                        |   8 +-
 src/models/UserModel.php                           |  81 ++++++
 src/views/elements/ManageaccountElement.php        |  43 +++-
 src/views/elements/ServersettingsElement.php       |  19 ++
 34 files changed, 3793 insertions(+), 2972 deletions(-)
 mode change 100644 => 100755 src/locale/en_US/configure.ini
 mode change 100644 => 100755 src/locale/nl/configure.ini
 mode change 100644 => 100755 src/locale/nl/statistics.txt
 mode change 100644 => 100755 src/locale/te/configure.ini

diff --git a/src/configs/Config.php b/src/configs/Config.php
index c6bb224..4dae5c2 100755
--- a/src/configs/Config.php
+++ b/src/configs/Config.php
@@ -112,7 +112,7 @@ function nsconddefine($constant, $value)
  * Version number for upgrade function
  * @var int
  */
-nsdefine('YIOOP_VERSION', 45);
+nsdefine('YIOOP_VERSION', 46);
 /**
  * Minimum Version fo Yioop for which keyword ad script
  * still works with this version
@@ -449,6 +449,8 @@ nsdefine('ADMIN_ROLE', 1);
 nsdefine('USER_ROLE', 2);
 /** Default role of an advertiser */
 nsdefine('BUSINESS_ROLE', 3);
+/** Default role of a bot user */
+nsdefine('BOT_ROLE', 4);
 /** ID of the group to which all Yioop users belong */
 nsdefine('PUBLIC_GROUP_ID', 2);
 /** ID of the group to which all Yioop users belong */
diff --git a/src/configs/Createdb.php b/src/configs/Createdb.php
index 3473a56..d09194a 100755
--- a/src/configs/Createdb.php
+++ b/src/configs/Createdb.php
@@ -50,6 +50,7 @@ require_once __DIR__."/../library/LocaleFunctions.php";
 /** To make it easy to insert translations */
 require_once __DIR__."/../library/UpgradeFunctions.php";
 $profile_model = new ProfileModel(DB_NAME, false);
+
 $db_class = NS_DATASOURCES . ucfirst(DBMS)."Manager";
 $dbinfo = ["DBMS" => DBMS, "DB_HOST" => DB_HOST, "DB_USER" => DB_USER,
     "DB_PASSWORD" => DB_PASSWORD, "DB_NAME" => DB_NAME];
@@ -67,12 +68,16 @@ if (!in_array(DBMS, ['sqlite', 'sqlite3'])) {
     $db->execute("DROP DATABASE IF EXISTS " . DB_NAME);
     $db->execute("CREATE DATABASE " . DB_NAME);
     $db->disconnect();
-
     $db->connect(); // default connection goes to actual DB
+
 } else {
     @unlink(CRAWL_DIR."/data/" . DB_NAME . ".db");
+    echo "hi0";
     $db = new $db_class();
+    echo "hi1";
     $db->connect();
+    echo "hi2";
+
 }
 if (!$profile_model->createDatabaseTables($db, $dbinfo)) {
     echo "\n\nCouldn't create database tables!!!\n\n";
@@ -120,6 +125,7 @@ $now = time();
 $db->execute("INSERT INTO ROLE VALUES (".ADMIN_ROLE.", 'Admin' )");
 $db->execute("INSERT INTO ROLE VALUES (".USER_ROLE.", 'User' )");
 $db->execute("INSERT INTO ROLE VALUES (".BUSINESS_ROLE.", 'Business User' )");
+$db->execute("INSERT INTO ROLE VALUES (".BOT_ROLE.", 'Bot User' )");
 $db->execute("INSERT INTO USER_ROLE VALUES (".ROOT_ID.", ".ADMIN_ROLE.")");
 $db->execute("INSERT INTO USER_GROUP VALUES (".ROOT_ID.", ".
     PUBLIC_GROUP_ID.", ".ACTIVE_STATUS.", $now)");
diff --git a/src/controllers/components/AccountaccessComponent.php b/src/controllers/components/AccountaccessComponent.php
index b8068b4..5e5c37e 100644
--- a/src/controllers/components/AccountaccessComponent.php
+++ b/src/controllers/components/AccountaccessComponent.php
@@ -81,12 +81,18 @@ class AccountaccessComponent extends Component
         $data['SCRIPT'] = "";
         $data['MESSAGE'] = "";
         $data['yioop_advertisement'] = $profile['ADVERTISEMENT_TYPE'];
+        $data['yioop_bot_configuration'] = $profile['CONFIGURE_BOT'];
         if (!in_array($profile['ADVERTISEMENT_TYPE'],
             ['no_advertisements','external_advertisements'])) {
             $data['yioop_advertisement'] = true;
         } else {
             $data['yioop_advertisement'] = false;
         }
+        if ($profile['CONFIGURE_BOT'] == 'enable_bot_users') {
+            $data['yioop_bot_configuration'] = true;
+        } else {
+            $data['yioop_bot_configuration'] = false;
+        }
         $user_id = $_SESSION['USER_ID'];
         $username = $signin_model->getUserName($user_id);
         $data["USER"] = $user_model->getUser($username);
@@ -290,6 +296,25 @@ class AccountaccessComponent extends Component
                     $data['USER']['IS_ADVERTISER'] = $user['IS_ADVERTISER'];
                     $role_model->deleteUserRole($user_id, $business_id);
                 }
+                $bot_role_id=$role_model->getRoleId('Bot User');
+                if(isset($_REQUEST['IS_BOT_USER']) && $bot_role_id){
+                    $data['USER']['IS_BOT_USER'] = 1;
+                    $role_model->addUserRole($user_id, $bot_role_id);
+                } else if ($bot_role_id) {
+                    $data['USER']['IS_BOT_USER'] = 0;
+                    $role_model->deleteUserRole($user_id, $bot_role_id);
+                }
+                $is_bot_updated = false;
+                if(isset($_REQUEST['BOT_TOKEN'])){
+                    $user['BOT_TOKEN'] = $_REQUEST['BOT_TOKEN'];
+                    $data['USER']['BOT_TOKEN'] = $user['BOT_TOKEN'];
+                    $is_bot_updated=true;
+                }
+                if(isset($_REQUEST['BOT_CALLBACK_URL'])){
+                    $user['CALLBACK_URL'] = $_REQUEST['BOT_CALLBACK_URL'];
+                    $data['USER']['CALLBACK_URL'] = $user['CALLBACK_URL'];
+                    $is_bot_updated=true;
+                }
                 if(isset($_FILES['user_icon']['name']) &&
                     $_FILES['user_icon']['name'] !="") {
                     if (!in_array($_FILES['user_icon']['type'],
@@ -314,6 +339,9 @@ class AccountaccessComponent extends Component
                     }
                 }
                 $user_model->updateUser($user);
+                if($is_bot_updated) {
+                    $user_model->updateBot($user);
+                }
                 $data['USER']['USER_ICON'] = $user_model->getUserIconUrl(
                     $user['USER_ID']);
                 unset($user['IMAGE_STRING']);
diff --git a/src/controllers/components/SystemComponent.php b/src/controllers/components/SystemComponent.php
index ec5a780..fa57e7a 100755
--- a/src/controllers/components/SystemComponent.php
+++ b/src/controllers/components/SystemComponent.php
@@ -655,6 +655,12 @@ class SystemComponent extends Component
             'external_advertisements' =>
                 tl('system_component_configure_external_advertisements'),
              );
+        $data['CONFIGURE_BOTS'] = array (
+            'enable_bot_users' =>
+                tl('system_component_configure_enable_bot_users'),
+            'disable_bot_users' =>
+                tl('system_component_configure_disable_bot_users')
+             );
         $data['show_mail_info'] = "false";
         if (isset($data['REGISTRATION_TYPE']) &&
             in_array($data['REGISTRATION_TYPE'],
diff --git a/src/library/VersionFunctions.php b/src/library/VersionFunctions.php
index e345541..4726f66 100644
--- a/src/library/VersionFunctions.php
+++ b/src/library/VersionFunctions.php
@@ -912,6 +912,7 @@ function upgradeDatabaseVersion32(&$db)
         PRIMARY KEY $auto_increment, USER_ID INTEGER,
         ADV_NAME VARCHAR(". C\ADVERTISEMENT_NAME_LEN ."),
         ADV_DESCRIPTION VARCHAR(". C\ADVERTISEMENT_TEXT_LEN ."),
+        ADV_DESCRIPTION VARCHAR(". C\ADVERTISEMENT_TEXT_LEN ."),
         ADV_DESTINATION VARCHAR(". C\ADVERTISEMENT_DESTINATION_LEN ."),
         ADV_KEYWORDS VARCHAR(". C\ADVERTISEMENT_KEYWORD_LEN ."),
         STATUS INTEGER, ADV_BUDGET INTEGER,
@@ -1276,3 +1277,13 @@ function upgradeDatabaseVersion45(&$db)
         $db->execute($sql, $scraper);
     }
 }
+/**
+ * Upgrades a Version 45 version of the Yioop! database to a Version 46 version
+ * @param object $db datasource to use to upgrade.
+ */
+function upgradeDatabaseVersion46(&$db)
+{
+    $db->execute("CREATE TABLE CHAT_BOT (
+        USER_ID INTEGER PRIMARY KEY, BOT_TOKEN CHAR(". C\TIMESTAMP_LEN .
+        ") UNIQUE, CALLBACK_URL VARCHAR(" . C\MAX_URL_LEN . "))");
+}
diff --git a/src/locale/ar/configure.ini b/src/locale/ar/configure.ini
index b8a1f9f..13cbccb 100755
--- a/src/locale/ar/configure.ini
+++ b/src/locale/ar/configure.ini
@@ -26,7 +26,7 @@
 ;
 [strings]
 ;
-; /Applications/MAMP/htdocs/git/yioop/src/controllers
+; /Applications/XAMPP/xamppfiles/htdocs/yioop/src/controllers
 ;
 ; AdminController.php line: 114
 admin_controller_need_cookies = ""
@@ -94,174 +94,174 @@ admin_controller_sort_ascending = ""
 ; AdminController.php line: 582
 admin_controller_sort_descending = ""
 ;
-; /Applications/MAMP/htdocs/git/yioop/src/controllers/components
+; /Applications/XAMPP/xamppfiles/htdocs/yioop/src/controllers/components
 ;
-; AccountaccessComponent.php line: 221
+; AccountaccessComponent.php line: 227
 accountaccess_component_no_posts_yet = ""
 ;
-; AccountaccessComponent.php line: 238
+; AccountaccessComponent.php line: 244
 accountaccess_component_passwords_too_long = ""
 ;
-; AccountaccessComponent.php line: 248
+; AccountaccessComponent.php line: 254
 accountaccess_component_passwords_dont_match = "لا تتطابق كلمات المرور المكتوبة."
 ;
-; AccountaccessComponent.php line: 255
+; AccountaccessComponent.php line: 261
 accountaccess_component_invalid_password = ""
 ;
-; AccountaccessComponent.php line: 297
+; AccountaccessComponent.php line: 311
 accountaccess_component_unknown_imagetype = ""
 ;
-; AccountaccessComponent.php line: 302
+; AccountaccessComponent.php line: 316
 accountaccess_component_icon_too_big = ""
 ;
-; AccountaccessComponent.php line: 311
+; AccountaccessComponent.php line: 325
 accountaccess_component_no_user_folder = ""
 ;
-; AccountaccessComponent.php line: 320
+; AccountaccessComponent.php line: 334
 accountaccess_component_user_updated = ""
 ;
-; AccountaccessComponent.php line: 375
+; AccountaccessComponent.php line: 389
 accountaccess_component_active_status = ""
 ;
-; AccountaccessComponent.php line: 376
+; AccountaccessComponent.php line: 390
 accountaccess_component_inactive_status = ""
 ;
-; AccountaccessComponent.php line: 378
+; AccountaccessComponent.php line: 392
 accountaccess_component_suspended_status = ""
 ;
-; AccountaccessComponent.php line: 381
+; AccountaccessComponent.php line: 395
 accountaccess_component_request_join = ""
 ;
-; AccountaccessComponent.php line: 382
+; AccountaccessComponent.php line: 396
 accountaccess_component_invited = ""
 ;
-; AccountaccessComponent.php line: 383
+; AccountaccessComponent.php line: 397
 accountaccess_component_active_status = ""
 ;
-; AccountaccessComponent.php line: 385
+; AccountaccessComponent.php line: 399
 accountaccess_component_suspended_status = ""
 ;
-; AccountaccessComponent.php line: 434
+; AccountaccessComponent.php line: 448
 accountaccess_component_passwords_too_long = ""
 ;
-; AccountaccessComponent.php line: 439
+; AccountaccessComponent.php line: 453
 accountaccess_component_passwords_dont_match = "لا تتطابق كلمات المرور المكتوبة."
 ;
-; AccountaccessComponent.php line: 443
+; AccountaccessComponent.php line: 457
 accountaccess_component_invalid_username = ""
 ;
-; AccountaccessComponent.php line: 447
+; AccountaccessComponent.php line: 461
 accountaccess_component_user_exists = ""
 ;
-; AccountaccessComponent.php line: 476
+; AccountaccessComponent.php line: 490
 accountaccess_component_user_added = ""
 ;
-; AccountaccessComponent.php line: 488
+; AccountaccessComponent.php line: 502
 accountaccess_component_user_doesnt_exist = ""
 ;
-; AccountaccessComponent.php line: 495
+; AccountaccessComponent.php line: 509
 accountaccess_component_cant_edit_public_user = ""
 ;
-; AccountaccessComponent.php line: 537
+; AccountaccessComponent.php line: 551
 accountaccess_component_passwords_dont_match = "لا تتطابق كلمات المرور المكتوبة."
 ;
-; AccountaccessComponent.php line: 543
+; AccountaccessComponent.php line: 557
 accountaccess_component_user_updated = ""
 ;
-; AccountaccessComponent.php line: 549
+; AccountaccessComponent.php line: 563
 accountaccess_component_user_filter_group = ""
 ;
-; AccountaccessComponent.php line: 553
+; AccountaccessComponent.php line: 567
 accountaccess_component_user_filter_role = ""
 ;
-; AccountaccessComponent.php line: 568
+; AccountaccessComponent.php line: 582
 accountaccess_component_username_doesnt_exists = "اسم المستخدم غير موجود"
 ;
-; AccountaccessComponent.php line: 573
+; AccountaccessComponent.php line: 587
 accountaccess_component_cant_delete_builtin = ""
 ;
-; AccountaccessComponent.php line: 578
+; AccountaccessComponent.php line: 592
 accountaccess_component_user_deleted = ""
 ;
-; AccountaccessComponent.php line: 587
+; AccountaccessComponent.php line: 601
 accountaccess_component_username_doesnt_exists = "اسم المستخدم غير موجود"
 ;
-; AccountaccessComponent.php line: 592
+; AccountaccessComponent.php line: 606
 accountaccess_component_rolename_doesnt_exists = "دور الاسم غير موجود"
 ;
-; AccountaccessComponent.php line: 598
+; AccountaccessComponent.php line: 612
 accountaccess_component_rolename_already_added = ""
 ;
-; AccountaccessComponent.php line: 604
+; AccountaccessComponent.php line: 618
 accountaccess_component_rolename_added = "دور إضافة اسم"
 ;
-; AccountaccessComponent.php line: 614
+; AccountaccessComponent.php line: 628
 accountaccess_component_username_doesnt_exists = "اسم المستخدم غير موجود"
 ;
-; AccountaccessComponent.php line: 619
+; AccountaccessComponent.php line: 633
 accountaccess_component_groupname_doesnt_exists = ""
 ;
-; AccountaccessComponent.php line: 625
+; AccountaccessComponent.php line: 639
 accountaccess_component_groupname_already_added = ""
 ;
-; AccountaccessComponent.php line: 633
+; AccountaccessComponent.php line: 647
 accountaccess_component_groupname_added = ""
 ;
-; AccountaccessComponent.php line: 643
+; AccountaccessComponent.php line: 657
 accountaccess_component_username_doesnt_exists = "اسم المستخدم غير موجود"
 ;
-; AccountaccessComponent.php line: 649
+; AccountaccessComponent.php line: 663
 accountaccess_component_rolename_doesnt_exists = "دور الاسم غير موجود"
 ;
-; AccountaccessComponent.php line: 658
+; AccountaccessComponent.php line: 672
 accountaccess_component_rolename_deleted = "دور حذف اسم"
 ;
-; AccountaccessComponent.php line: 672
+; AccountaccessComponent.php line: 686
 accountaccess_component_username_doesnt_exists = "اسم المستخدم غير موجود"
 ;
-; AccountaccessComponent.php line: 677
+; AccountaccessComponent.php line: 691
 accountaccess_component_groupname_doesnt_exists = ""
 ;
-; AccountaccessComponent.php line: 686
+; AccountaccessComponent.php line: 700
 accountaccess_component_group_deleted = ""
 ;
-; AccountaccessComponent.php line: 716
+; AccountaccessComponent.php line: 731
 accountaccess_component_username_doesnt_exists = "اسم المستخدم غير موجود"
 ;
-; AccountaccessComponent.php line: 722
+; AccountaccessComponent.php line: 737
 accountaccess_component_userstatus_updated = ""
 ;
-; AccountaccessComponent.php line: 898
+; AccountaccessComponent.php line: 913
 accountaccess_component_select_activityname = "حدد النشاط"
 ;
-; AccountaccessComponent.php line: 923
+; AccountaccessComponent.php line: 938
 accountaccess_component_rolename_doesnt_exists = "دور الاسم غير موجود"
 ;
-; AccountaccessComponent.php line: 939
+; AccountaccessComponent.php line: 954
 accountaccess_component_activity_added = "وأضاف النشاط"
 ;
-; AccountaccessComponent.php line: 948
+; AccountaccessComponent.php line: 963
 accountaccess_component_rolename_exists = "دور الاسم موجود"
 ;
-; AccountaccessComponent.php line: 954
+; AccountaccessComponent.php line: 969
 accountaccess_component_rolename_added = "دور إضافة اسم"
 ;
-; AccountaccessComponent.php line: 958
+; AccountaccessComponent.php line: 973
 accountaccess_component_rolename_blank = ""
 ;
-; AccountaccessComponent.php line: 967
+; AccountaccessComponent.php line: 982
 accountaccess_component_rolename_doesnt_exists = "دور الاسم غير موجود"
 ;
-; AccountaccessComponent.php line: 985
+; AccountaccessComponent.php line: 1000
 accountaccess_component_activity_deleted = "حذف النشاط"
 ;
-; AccountaccessComponent.php line: 998
+; AccountaccessComponent.php line: 1013
 accountaccess_component_rolename_doesnt_exists = "دور الاسم غير موجود"
 ;
-; AccountaccessComponent.php line: 1004
+; AccountaccessComponent.php line: 1019
 accountaccess_component_rolename_deleted = "دور حذف اسم"
 ;
-; AccountaccessComponent.php line: 1039
+; AccountaccessComponent.php line: 1054
 accountaccess_component_role_updated = ""
 ;
 ; AdvertisementComponent.php line: 60
@@ -1380,118 +1380,124 @@ system_component_configure_keyword_advertisements = ""
 ; SystemComponent.php line: 655
 system_component_configure_external_advertisements = ""
 ;
-; SystemComponent.php line: 738
+; SystemComponent.php line: 659
+system_component_configure_enable_bot_users = ""
+;
+; SystemComponent.php line: 661
+system_component_configure_disable_bot_users = ""
+;
+; SystemComponent.php line: 744
 captchasettings_element_text_captcha = ""
 ;
-; SystemComponent.php line: 740
+; SystemComponent.php line: 746
 captchasettings_element_hash_captcha = ""
 ;
-; SystemComponent.php line: 742
+; SystemComponent.php line: 748
 captchasettings_element_image_captcha = ""
 ;
-; SystemComponent.php line: 746
+; SystemComponent.php line: 752
 captchasettings_element_no_recovery = ""
 ;
-; SystemComponent.php line: 748
+; SystemComponent.php line: 754
 captchasettings_element_email_recovery = ""
 ;
-; SystemComponent.php line: 750
+; SystemComponent.php line: 756
 captchasettings_element_email_questions = ""
 ;
-; SystemComponent.php line: 755
+; SystemComponent.php line: 761
 serversettings_element_normal_authentication = ""
 ;
-; SystemComponent.php line: 757
+; SystemComponent.php line: 763
 serversettings_element_zkp_authentication = ""
 ;
-; SystemComponent.php line: 762
+; SystemComponent.php line: 768
 serversettings_element_normal_authentication = ""
 ;
-; SystemComponent.php line: 791
+; SystemComponent.php line: 797
 system_component_settings_updated = ""
 ;
-; SystemComponent.php line: 794
+; SystemComponent.php line: 800
 system_component_no_update_settings = ""
 ;
-; SystemComponent.php line: 836
+; SystemComponent.php line: 842
 system_component_no_resource_folder = ""
 ;
-; SystemComponent.php line: 850
+; SystemComponent.php line: 856
 system_component_invalid_filetype = ""
 ;
-; SystemComponent.php line: 855
+; SystemComponent.php line: 861
 system_component_file_too_big = ""
 ;
-; SystemComponent.php line: 870
+; SystemComponent.php line: 876
 system_component_configure_profile_change = "تحديث الشخصية!"
 ;
-; SystemComponent.php line: 874
+; SystemComponent.php line: 880
 system_component_configure_no_change_profile = "كان هناك ملفتعريف تحديث المشكلة!"
 ;
-; SystemComponent.php line: 923
+; SystemComponent.php line: 929
 system_component_configure_reset_completed = ""
 ;
-; SystemComponent.php line: 926
+; SystemComponent.php line: 932
 system_component_configure_no_change_profile = "كان هناك ملفتعريف تحديث المشكلة!"
 ;
-; SystemComponent.php line: 1005
+; SystemComponent.php line: 1011
 system_component_configure_use_absolute_path = "يجب استخدام مسار مطلق لدليل العمل"
 ;
-; SystemComponent.php line: 1010
+; SystemComponent.php line: 1016
 system_component_configure_configure_diff_base_dir = ""
 ;
-; SystemComponent.php line: 1041
+; SystemComponent.php line: 1047
 system_component_configure_work_dir_set = "تعيين دليل العمل! قد تحتاج إلى إعادة تسجيل الدخول! "
 ;
-; SystemComponent.php line: 1052
+; SystemComponent.php line: 1058
 system_component_name_your_bot = "الرجاء تسمية الروبوت الخاص بك"
 ;
-; SystemComponent.php line: 1073
+; SystemComponent.php line: 1079
 system_component_configure_work_profile_made = "يعمل الدليل والشخصية التي تم إنشاؤها!"
 ;
-; SystemComponent.php line: 1077
+; SystemComponent.php line: 1083
 system_component_configure_no_set_config = "تعذر التحديث config.php الملف!"
 ;
-; SystemComponent.php line: 1084
+; SystemComponent.php line: 1090
 system_component_configure_no_create_profile = "غير قادر على إنشاء الشخصية!"
 ;
-; SystemComponent.php line: 1091
+; SystemComponent.php line: 1097
 system_component_configure_work_dir_invalid = "دليل العمل هو صالح! لا يمكن إنشاء الشخصية! "
 ;
-; SystemComponent.php line: 1098
+; SystemComponent.php line: 1104
 system_component_configure_work_dir_invalid = "دليل العمل هو صالح! لا يمكن إنشاء الشخصية! "
 ;
-; SystemComponent.php line: 1127
+; SystemComponent.php line: 1133
 system_component_configure_profile_change = "تحديث الشخصية!"
 ;
-; SystemComponent.php line: 1131
+; SystemComponent.php line: 1137
 system_component_configure_no_change_profile = "كان هناك ملفتعريف تحديث المشكلة!"
 ;
-; SystemComponent.php line: 1151
+; SystemComponent.php line: 1157
 system_component_describe_robot = "يرجى وصف الروبوت الخاص بك"
 ;
-; SystemComponent.php line: 1205
+; SystemComponent.php line: 1211
 system_component_php_version = "بي إتش بي 4لإصدار 5.3 أو أحدث"
 ;
-; SystemComponent.php line: 1213
+; SystemComponent.php line: 1219
 system_component_no_write_config_php = "configs/config.php ليس ملقم ويب للكتابة."
 ;
-; SystemComponent.php line: 1218
+; SystemComponent.php line: 1224
 system_component_no_write_work_dir = "دليل العمل يجب أن يكون قابل للكتابة من قبل ملقم ويب."
 ;
-; SystemComponent.php line: 1223
+; SystemComponent.php line: 1229
 system_component_post_size_small = "pnp.ini ملف post_max_size متغيرينبغي أن يكون مالا يقل عن 32 م"
 ;
-; SystemComponent.php line: 1229
+; SystemComponent.php line: 1235
 system_component_missing_required = "مطلوب ما يلي العناصر في عداد المفقودين:  %s"
 ;
-; SystemComponent.php line: 1253
+; SystemComponent.php line: 1259
 system_component_missing_optional = "كانت العناصر الاختيارية التالية مفقودة:  %s"
 ;
-; SystemComponent.php line: 1259
+; SystemComponent.php line: 1265
 system_component_check_passed = "تمرير الاختيار."
 ;
-; SystemComponent.php line: 1264
+; SystemComponent.php line: 1270
 system_component_using_local_config = "استخدام configs/local_config.php حتى تغيير دليل العمل أعلاه قد لا تعمل."
 ;
 ; Controller.php line: 127
@@ -1788,7 +1794,7 @@ statistics_controller_server = ""
 ; StatisticsController.php line: 204
 statistics_controller_os = ""
 ;
-; /Applications/MAMP/htdocs/git/yioop/src/views
+; /Applications/XAMPP/xamppfiles/htdocs/yioop/src/views
 ;
 ; AdminView.php line: 75
 admin_view_admin = "Admin"
@@ -1925,7 +1931,7 @@ crawlstatus_view_delete = "حذف"
 ; CrawlstatusView.php line: 269
 crawlstatus_view_no_previous_crawl = "لا توجد عمليات تتبع الارتباطات السابقة"
 ;
-; /Applications/MAMP/htdocs/git/yioop/src/views/elements
+; /Applications/XAMPP/xamppfiles/htdocs/yioop/src/views/elements
 ;
 ; ActivityElement.php line: 56
 activity_element_activities = "الأنشطة"
@@ -2443,85 +2449,94 @@ manageusers_element_email = ""
 ; ManageaccountElement.php line: 175
 manageaccount_element_is_advertiser = ""
 ;
-; ManageaccountElement.php line: 188
+; ManageaccountElement.php line: 190
+manageaccount_element_is_bot = ""
+;
+; ManageaccountElement.php line: 204
+manageaccount_element_bot_unique_token = ""
+;
+; ManageaccountElement.php line: 211
+manageaccount_element_bot_callback_url = ""
+;
+; ManageaccountElement.php line: 222
 manageaccount_element_password = ""
 ;
-; ManageaccountElement.php line: 195
+; ManageaccountElement.php line: 229
 manageaccount_element_new_password = "كلمة المرور الجديدة:"
 ;
-; ManageaccountElement.php line: 201
+; ManageaccountElement.php line: 235
 manageaccount_element_retype_password = "إعادة كتابة كلمة المرور:"
 ;
-; ManageaccountElement.php line: 211
+; ManageaccountElement.php line: 245
 manageaccount_element_new_recovery_qa = ""
 ;
-; ManageaccountElement.php line: 243
+; ManageaccountElement.php line: 277
 manageaccount_element_save = "حفظ"
 ;
-; ManageaccountElement.php line: 249
+; ManageaccountElement.php line: 283
 manageaccount_element_search_lang_settings = ""
 ;
-; ManageaccountElement.php line: 254
+; ManageaccountElement.php line: 288
 manageaccount_element_crawl_and_index = ""
 ;
-; ManageaccountElement.php line: 255
+; ManageaccountElement.php line: 289
 manageaccount_element_crawl_info = ""
 ;
-; ManageaccountElement.php line: 256
+; ManageaccountElement.php line: 290
 manageaccount_element_num_crawls = ""
 ;
-; ManageaccountElement.php line: 259
+; ManageaccountElement.php line: 293
 manageaccount_element_manage_crawls = ""
 ;
-; ManageaccountElement.php line: 261
+; ManageaccountElement.php line: 295
 manageaccount_element_query_statistics = ""
 ;
-; ManageaccountElement.php line: 266
+; ManageaccountElement.php line: 300
 manageaccount_element_groups_and_feeds = ""
 ;
-; ManageaccountElement.php line: 267
+; ManageaccountElement.php line: 301
 manageaccount_element_group_info = ""
 ;
-; ManageaccountElement.php line: 269
+; ManageaccountElement.php line: 303
 manageaccount_element_num_groups = ""
 ;
-; ManageaccountElement.php line: 272
+; ManageaccountElement.php line: 306
 manageaccount_element_num_group = ""
 ;
-; ManageaccountElement.php line: 289
+; ManageaccountElement.php line: 323
 manageaccount_element_manage = ""
 ;
-; ManageaccountElement.php line: 292
+; ManageaccountElement.php line: 326
 manageaccount_element_statistics = ""
 ;
-; ManageaccountElement.php line: 304
+; ManageaccountElement.php line: 338
 manageaccount_element_group_wiki = ""
 ;
-; ManageaccountElement.php line: 306
+; ManageaccountElement.php line: 340
 manageaccount_element_group_stats = ""
 ;
-; ManageaccountElement.php line: 311
+; ManageaccountElement.php line: 345
 manageaccount_element_last_post = ""
 ;
-; ManageaccountElement.php line: 321
+; ManageaccountElement.php line: 355
 manageaccount_element_manage_all_groups = ""
 ;
-; ManageaccountElement.php line: 323
+; ManageaccountElement.php line: 357
 manageaccount_element_go_to_group_feed = ""
 ;
-; ManageaccountElement.php line: 324
+; ManageaccountElement.php line: 358
 manageaccount_element_crawl_mixes = ""
 ;
-; ManageaccountElement.php line: 325
+; ManageaccountElement.php line: 359
 manageaccount_element_mixes_info = ""
 ;
-; ManageaccountElement.php line: 327
+; ManageaccountElement.php line: 361
 manageaccount_element_num_mixes = ""
 ;
-; ManageaccountElement.php line: 330
+; ManageaccountElement.php line: 364
 manageaccount_element_num_mix = ""
 ;
-; ManageaccountElement.php line: 334
+; ManageaccountElement.php line: 368
 manageaccount_element_manage_mixes = ""
 ;
 ; ManageadvertisementsElement.php line: 59
@@ -3925,7 +3940,13 @@ serversettings_element_top_adscript = ""
 ; ServersettingsElement.php line: 319
 serversettings_element_side_adscript = ""
 ;
-; ServersettingsElement.php line: 329
+; ServersettingsElement.php line: 330
+serversettings_element_bot_configuration = ""
+;
+; ServersettingsElement.php line: 335
+serversettings_element_bot_settings = ""
+;
+; ServersettingsElement.php line: 348
 serversettings_element_save = ""
 ;
 ; SigninElement.php line: 73
@@ -4300,7 +4321,7 @@ group_view_myfeeds = ""
 ; GroupView.php line: 201
 adminview_auto_logout_one_minute = "خروج السيارات في دقيقة واحدة!!"
 ;
-; /Applications/MAMP/htdocs/git/yioop/src/views/helpers
+; /Applications/XAMPP/xamppfiles/htdocs/yioop/src/views/helpers
 ;
 ; FeedsHelper.php line: 70
 feeds_helper_view_feed_results = "نتائج أخبار ل  %s"
@@ -4419,7 +4440,7 @@ toggle_helper_on = "على"
 ; ToggleHelper.php line: 73
 toggle_helper_off = "إيقاف"
 ;
-; /Applications/MAMP/htdocs/git/yioop/src/views/layouts
+; /Applications/XAMPP/xamppfiles/htdocs/yioop/src/views/layouts
 ;
 ; RssLayout.php line: 62
 rss_layout_title = "بي إتش بي محرك البحث-يوب!:  %s"
@@ -4961,6 +4982,9 @@ wiki_element_edit_page = ""
 ; WikiView.php line: 109
 wiki_element_page_history = ""
 ;
+; WikiView.php line: 111
+wiki_element_page_links = ""
+;
 ; WikiView.php line: 116
 wiki_element_read_page = ""
 ;
@@ -4970,6 +4994,9 @@ wiki_element_page_source = ""
 ; WikiView.php line: 121
 wiki_element_page_history = ""
 ;
+; WikiView.php line: 123
+wiki_element_page_links = ""
+;
 ; WikiView.php line: 129
 wiki_element_page_discuss = ""
 ;
@@ -4982,7 +5009,7 @@ wiki_element_group_feed = ""
 ; WikiView.php line: 197
 adminview_auto_logout_one_minute = "خروج السيارات في دقيقة واحدة!!"
 ;
-; /Applications/MAMP/htdocs/git/yioop/src/library/indexing_plugins
+; /Applications/XAMPP/xamppfiles/htdocs/yioop/src/library/indexing_plugins
 ;
 ; WordfilterPlugin.php line: 355
 wordfilter_plugin_settings_saved = ""
